/*
 * Copyright (C) 2020 ~ 2021 Uniontech Software Technology Co.,Ltd.
 *
 * Author:     Ji XiangLong <jixianglong@uniontech.com>
 *
 * Maintainer: WangYu <wangyu@uniontech.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef CVALIDATOR_H
#define CVALIDATOR_H

#include <QIntValidator>

class CIntValidator : public QIntValidator
{
public:
    explicit CIntValidator(int bottom, int top, QObject *parent = nullptr);

    void setEmptyStrToBottom(bool b);
    //bool emptyStrIsBottom()const;

    virtual State validate(QString &, int &) const override;
    virtual void fixup(QString &) const override;


private:
    bool m_emptyStrIsBottom = true;
};

#endif // CVALIDATOR_H
